Imports System.IO

Public Class Form1

  Private sDataFilename As String
  Private bEditMode As Boolean
  Private bTextHasChanged As Boolean

  Private Sub cmdCalc_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdCalc.Click
    Dim objLR As CStatSum
    Dim objRes As CResults
    Dim I, N, nDataCount As Integer
    Dim fShiftArr(3), fScaleArr(3) As Double
    Dim sBuffer As String

    If sDataFilename = "" Then
      MessageBox.Show("Please select a data file first", "Error", MessageBoxButtons.OK, MessageBoxIcon.Hand)
      Exit Sub
    End If

    If bTextHasChanged Then
      If MessageBox.Show("Save changed data?", "Confirmation", MessageBoxButtons.YesNo, MessageBoxIcon.Question) = Windows.Forms.DialogResult.Yes Then
        File.WriteAllText(sDataFilename, txtRes.Text)
      End If
      bTextHasChanged = False
    End If
    bEditMode = False

    If txtMaxResults.Text.Length > 0 Then
      N = Integer.Parse(txtMaxResults.Text)
      If N < 1 Then N = 32000
    Else
      N = 32000
    End If

    objLR = New CStatSum
    objRes = New CResults

    ' check the Shift Y text box
    If txtShiftY.Text.Length > 0 Then
      fShiftArr(0) = Double.Parse(txtShiftY.Text)
    Else
      fShiftArr(0) = 0
    End If

    ' check the Shift X1 text box
    If txtShiftX1.Text.Length > 0 Then
      fShiftArr(1) = Double.Parse(txtShiftX1.Text)
    Else
      fShiftArr(1) = 0
    End If

    ' check the Shift X2 text box
    If txtShiftX2.Text.Length > 0 Then
      fShiftArr(2) = Double.Parse(txtShiftX2.Text)
    Else
      fShiftArr(2) = 0
    End If

    ' check the Scale Y text box
    If txtScaleY.Text.Length > 0 Then
      fScaleArr(0) = Double.Parse(txtScaleY.Text)
      If fScaleArr(0) = 0 Then fScaleArr(0) = 1
    Else
      fScaleArr(0) = 1
    End If

    ' check the Scale X1 text box
    If txtScaleX1.Text.Length > 0 Then
      fScaleArr(1) = Double.Parse(txtScaleX1.Text)
      If fScaleArr(1) = 0 Then fScaleArr(1) = 1
    Else
      fScaleArr(1) = 1
    End If

    ' check the Scale X2 text box
    If txtScaleX2.Text.Length > 0 Then
      fScaleArr(2) = Double.Parse(txtScaleX2.Text)
      If fScaleArr(2) = 0 Then fScaleArr(2) = 1
    Else
      fScaleArr(2) = 1
    End If

    If objLR.GetData(sDataFilename, nDataCount, fShiftArr, fScaleArr) Then
      Cursor = Cursors.WaitCursor
      objLR.FindBestFit(objRes)
      objRes.SortResults()
      sBuffer = "Source Data File: " & sDataFilename & vbCrLf & vbCrLf
      sBuffer = sBuffer & "Date/Time: " & Now() & vbCrLf & vbCrLf
      sBuffer = sBuffer & "Nnmber of observations = " & nDataCount & vbCrLf & vbCrLf
      If fScaleArr(0) <> 1 Then sBuffer = sBuffer & "Scale Y = " & fScaleArr(0) & vbCrLf
      If fShiftArr(0) <> 0 Then sBuffer = sBuffer & "Shift Y = " & fShiftArr(0) & vbCrLf
      If fScaleArr(1) <> 1 Then sBuffer = sBuffer & "Scale X1 = " & fScaleArr(1) & vbCrLf
      If fShiftArr(1) <> 0 Then sBuffer = sBuffer & "Shift X1 = " & fShiftArr(1) & vbCrLf
      If fScaleArr(2) <> 1 Then sBuffer = sBuffer & "Scale X2 = " & fScaleArr(2) & vbCrLf
      If fShiftArr(2) <> 0 Then sBuffer = sBuffer & "Shift X2 = " & fShiftArr(2) & vbCrLf
      N = IIf(objRes.Count > N, N, objRes.Count)
      For I = 0 To N - 1
        sBuffer = sBuffer & "R-Sqr = " & objRes.GetR2(I).ToString & vbCrLf
        sBuffer = sBuffer & "Model: " & objRes.GetModel(I) & vbCrLf
        sBuffer = sBuffer & "A  = " & objRes.GetIntercept(I).ToString & _
                      ", B1 = " & objRes.GetSlope1(I).ToString & _
                      ", B2 = " & objRes.GetSlope2(I).ToString & vbCrLf
      Next
      txtRes.Text = sBuffer
      sBuffer = ""
      Cursor = Cursors.Default
      cmdSaveRes.Enabled = True
    Else
      MessageBox.Show("Error in processing data", "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
    End If
  End Sub

  Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
    sDataFilename = ""
    cmdCalc.Enabled = False
    cmdSaveRes.Enabled = False
    bEditMode = False
  End Sub

  Private Sub cmdReadData_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdReadData.Click
    dlgReadData.Filter = "All files (*.*)|*.*|Text files|*.txt|Data files (*.dat)|*.dat"
    If dlgReadData.ShowDialog = Windows.Forms.DialogResult.OK Then
      sDataFilename = dlgReadData.FileName
      txtRes.Text = File.ReadAllText(sDataFilename)
      cmdCalc.Enabled = True
      cmdSaveRes.Enabled = True
      bTextHasChanged = False
      bEditMode = True
    End If
  End Sub

  Private Sub cmdSaveRes_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdSaveRes.Click
    dlgSaveRes.Filter = "All files (*.*)|*.*|Text files|*.txt|Data files (*.dat)|*.dat"
    If dlgSaveRes.ShowDialog = Windows.Forms.DialogResult.OK Then
      File.WriteAllText(dlgSaveRes.FileName, txtRes.Text)
      bTextHasChanged = False
    End If
  End Sub

  Private Sub cmdClose_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdClose.Click
    If MessageBox.Show("Close application?", "Confirmation", MessageBoxButtons.YesNo, MessageBoxIcon.Question) = Windows.Forms.DialogResult.Yes Then
      Close()
    End If
  End Sub

  Private Sub txtRes_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtRes.TextChanged
    If bEditMode Then bTextHasChanged = True
  End Sub

  Private Sub cmdHelp_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdHelp.Click
    Dim sText As String
    Dim I As Integer

    sText = "Each line can be 1) empty, 2) a comment line or 3) a data line" & vbCrLf & _
            "A data line has a set of y, x1, and x2 values separated by commas" & vbCrLf & _
            "A data line can have a weight value that is appended after x2 and is separated by a comma" & vbCrLf & _
            "Weights are optional and need to appear when their values are not 1" & vbCrLf & _
            "A comment line must NOT start with any of the chatacters +-.0123456789" & vbCrLf & _
            "Show an example?"
    If MessageBox.Show(sText, "Help", MessageBoxButtons.YesNo, MessageBoxIcon.Information) = Windows.Forms.DialogResult.Yes Then
      bEditMode = False
      sText = "Sample data (example of free form comment line)" & vbCrLf & _
              "45,32,44" & vbCrLf & _
              "67,34,55" & vbCrLf & _
              "Next line is an observation that is temporaryly commente dout" & vbCrLf & _
              "! 56,23,18" & vbCrLf
      For I = 1 To 10
        sText = sText & Int(200 * Rnd(1)) & "," & Int(200 * Rnd(1)) & "," & Int(100 * Rnd(1)) & vbCrLf
      Next
      txtRes.Text = sText
    End If

  End Sub
End Class
